unit recode;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Gauges, SapDLG, SapTools;

type
  TfmRecode = class(TForm)
    MainMenu1: TMainMenu;
    mnuRead: TMenuItem;
    mnuRW: TMenuItem;
    mnuRD: TMenuItem;
    mnuRK: TMenuItem;
    mnuRL: TMenuItem;
    Panel1: TPanel;
    ListBox1: TListBox;
    mnuOptions: TMenuItem;
    mnuDosLines: TMenuItem;
    mnuUnixLines: TMenuItem;
    N1: TMenuItem;
    mnuWrite: TMenuItem;
    mnuWW: TMenuItem;
    mnuWD: TMenuItem;
    mnuWK: TMenuItem;
    mnuWL: TMenuItem;
    mnuFinish: TMenuItem;
    mnuTabs: TMenuItem;
    Memo1: TMemo;
    ListBox2: TListBox;
    N2: TMenuItem;
    mnuAsText: TMenuItem;
    mnuAsHex: TMenuItem;
    mnuBackToLatin: TMenuItem;
    mnuCutSelected: TMenuItem;
    Gauge1: TGauge;
    mnuStatist: TMenuItem;
    mnuRISO: TMenuItem;
    mnuNumerate: TMenuItem;
    mnuClearCol: TMenuItem;
    mnuPreamb: TMenuItem;
    mnuNoUnpack: TMenuItem;
    mnuBase64: TMenuItem;
    mnuUUE: TMenuItem;
    mnuMIMEQP: TMenuItem;
    mnuNewFile: TMenuItem;
    procedure mnuReadClick(Sender: TObject);
    procedure mnuWriteClick(Sender: TObject);
    procedure mnuLinesStyleClick(Sender: TObject);
    procedure mnuFinishClick(Sender: TObject);
    procedure mnuTabsClick(Sender: TObject);
    procedure KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuAsHexClick(Sender: TObject);
    procedure mnuAsTextClick(Sender: TObject);
    procedure mnuBackToLatinClick(Sender: TObject);
    procedure mnuCutSelectedClick(Sender: TObject);
    procedure mnuStatistClick(Sender: TObject);
    procedure mnuNumerateClick(Sender: TObject);
    procedure mnuClearColClick(Sender: TObject);
    procedure mnuPreambClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuNewFileClick(Sender: TObject);
  private
    { Private declarations }
    Procedure Front(who:integer);
  public
    { Public declarations }
  end;

var
  fmRecode: TfmRecode;

implementation

{$R *.DFM}

Const CR=$0D;
Const LF=$0A;
Const HT=$09;
Const FileChanged:boolean=false;
      OptionsEnabled:boolean=false;
      ColCount:integer=0;
      WhoIsOnFront:integer=0;          // Memo1
{              C               D               E               F                }
{              0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF }
Const Koi2Win='';
Const RusLet ='';
      LatEqu1='ABVGDEZZIJKLMNOPRSTUFXCCSS,Y,JJJabvgdezzijklmnoprstufxccss,y,jjj';
      LatEqu2='      h                hhc   eua      h                hhc   eua';
Const WHex=16;
      WrapL=250;      //   
      MaxBuf=250000;
      Numbered:boolean = false;
      Param:string='?';
      NewSource:boolean=true;
      SourceFile:string='';
      Destination:string='';

Var RcodeItem,WCodeItem:TMenuitem;
    Buf:array[1..MaxBuf+4] of byte;
    f:file;  Current,Last,Anal64:integer;
    s,Spec:string;
    stat:array[0..255] of integer;
    MaxLenS:integer;
    Top_Stat:integer;

Function Hex(b:byte):string;
var k:integer; c1,c2:char;
begin k:=b shr 4;
  if k<10 then c1:=Chr(k+Ord('0')) else c1:=Chr(k-10+Ord('A'));
  k:=b and 15; if k<10 then c2:=Chr(k+Ord('0')) else c2:=Chr(k-10+Ord('A'));
  Result:=c1+c2;
end;

Procedure Dos2Win(var b:byte);
begin if (b>=$E0) and (b<=$EF) then Inc(b,16)
  else if(b>=$80) and (b<=$AF) then Inc(b,64)
  else Case b of
         $F0: b:=$A8;
         $F1: b:=$B8;
       end;
end;

var mfin:boolean;
Function base64:byte;
begin Result:=0; if mfin then Exit;
  Repeat Inc(Anal64) Until Buf[Anal64]>32;  // skip CR,LF
  Result:=Pos(Chr(Buf[Anal64]),'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/') -1;
  if Buf[Anal64]=Ord('=') then mfin:=true;
end;

Function UUE:byte;
begin  Inc(Anal64);  Result:=(Buf[Anal64]-32) and 63;
end;

Procedure ReadBuf;
Const Sign='CONTENT-TRANSFER-ENCODING: BASE64';
var i,j,k:integer;
begin Anal64:=0; Current:=1; BlockRead(f,Buf,MaxBuf,Last);
  if (Last=0) or fmRecode.mnuNoUnpack.Checked or fmRecode.mnuMIMEQP.Checked then Exit;
  if fmRecode.mnuUUE.Checked then
  begin j:=1;
    Repeat Inc(Anal64);
      mfin:=((Buf[Anal64]>32) and (Buf[Anal64]<96));
      if not mfin then Dec(Anal64) else
      Repeat
        k:=(UUE shl 18) or (UUE shl 12) or (UUE shl 6) or UUE;
        Buf[j]:=k shr 16 and $FF;  Buf[j+1]:=k shr 8 and $FF; Buf[j+2]:=k and $FF;
        Inc(j,3);
      Until Buf[Anal64+1]<32;
      Repeat
        Inc(Anal64); Buf[j]:=Buf[Anal64];  if not mfin then Inc(j);
      Until (Anal64>Last) or (Buf[Anal64]=LF);
    Until Anal64>=Last;
    Last:=j-1; Exit;
  end;
  While Buf[Last]=Ord('=') do Dec(Last);
  for i:=Length(Sign) to Last-4 do   //  maybe Base64 ?
  begin s:='';  k:=i;
    if (Buf[i+4]=LF) and (Buf[i+3]=CR) and (Buf[i+2]=LF) and (Buf[i+1]=CR) then
      for j:=1 to Length(Sign) do s:=s+Chr(Buf[i-Length(Sign)+j]);
      if UpperCase(s)=Sign then begin Anal64:=k-Length(Sign)+1; Break; end;
  end;
  if Anal64=0 then Exit;
  i:=Anal64+Length(Sign)+4;    j:=i;  // ? Anal64;
  Anal64:=i-1;  mfin:=false;
  Repeat
    k:=(Base64 shl 18) or (Base64 shl 12) or (Base64 shl 6) or Base64;
    Buf[j]:=k shr 16 and $FF;  Buf[j+1]:=k shr 8 and $FF; Buf[j+2]:=k and $FF;
    Inc(i,4); Inc(j,3);
  Until mfin or (Anal64>=Last);
  Last:=j-1;  if Buf[Last]=$FF then Dec(Last);
end;

Function GetByte:byte;
begin if Current<0 then ReadBuf;
  Result:=Buf[Current];  s:=Chr(Result);
  Inc(Current); if Current>Last then ReadBuf;
end;

Function GetByteQP:byte;
begin
  Repeat Result:=GetByte;
    if Chr(Result) in ['0'..'9'] then Result:=Result-Ord('0')
      else if Chr(Result) in ['A'..'F'] then Result:=Result-Ord('A')+10
        else Result:=99;
  Until (Result<16) or (Current>Last);
end;

Procedure PutByte(b:byte);
begin Buf[Current]:=b; Inc(Current);
  if Current>Last then begin BlockWrite(f,Buf,Last); Current:=1; end;
end;

procedure TfmRecode.Front(who:integer);
begin WhoIsOnFront:=who; Case who of
  -1: Gauge1.BringToFront;
   0: With Memo1    do begin Self.Caption:=Hint; BringToFront; SetFocus; end;
   1: With ListBox1 do begin Self.Caption:=Hint; BringToFront; SetFocus; end;
   2: With ListBox2 do begin Self.Caption:=Hint; BringToFront; SetFocus; end;
   end;
end;

procedure TfmRecode.mnuReadClick(Sender: TObject);
var s,Le1,h1,h2:string; i,j,k,a,lh,n:integer; b,c:byte; cb:char;
Procedure PutStr;
var i:integer; u:string;
begin    Inc(n,1000001);
  if mnuClearCol.Checked then s:=TrimRight(Copy(s,1,72));
  if Length(s)>MaxLenS then MaxLenS:=Length(s);
  u:=UpperCase(s);  i:=-1;
  if (Pos('CHARSET',u)>0)   or (Pos('CONTENT-T',u)>0) or
     (Pos('MIME-VERS',u)>0) or (Pos('UUENCODE',u)>0) then
  begin i:=ListBox1.Items.Count;
    if Spec='' then Spec:='       :';
    if Length(Spec)<500 then Spec:=Spec+#13+s;
  end;
  if Numbered then
  begin
    if Length(s)>WrapL then s:=' > '+s else s:=' : '+s;
    s:=Copy(IntToStr(n),2,6)+s;
  end;
  ListBox1.Items.Add(s); if i>=0 then ListBox1.Selected[i]:=true;
  s:=''; Dec(n,1000000);
end;
begin ForceCurrentDirectory:=true;
  if Assigned(Sender) then RCodeItem:=(Sender as TMenuItem)
    else if mnuRW.Checked then RCodeItem:=mnuRW
      else if mnuRD.Checked then RCodeItem:=mnuRD
        else if mnuRK.Checked then RCodeItem:=mnuRK
          else if mnuRL.Checked then RCodeItem:=mnuRL
            else if mnuRISO.Checked then RCodeItem:=mnuRISO
              else RCodeItem:=mnuRW;
  RCodeItem.Checked:=true;
  s:=RCodeItem.Caption; i:=Pos('&',s); if i>0 then Delete(s,i,1);
  While SourceFile='' do mnuNewFileClick(Sender);
  {$I-} AssignFile(f,SourceFile); Reset(f,1); {$I+}
  if IoResult<>0 then
    begin Anons(',     '+SourceFile,mtError); SourceFile:=''; Exit; end;
  j:=FileSize(f); if j=0 then
    begin Anons(' '+SourceFile+' !',mtError); CloseFile(f); SourceFile:=''; Exit; end;
  Gauge1.MaxValue:=j; Gauge1.Progress:=0; Gauge1.Visible:=true; Front(-1);
  Screen.Cursor:=crHourGlass;
  ListBox1.Hint:=' '+SourceFile+'  '+s+'   (: '+IntToStr(j)+' )';
  ListBox2.Hint:=' '+SourceFile+'   16-   (: '+IntToStr(j)+' )';
  ListBox1.Clear;  ListBox1.Color:=clWhite;  ListBox1.Visible:=false;
  ListBox2.Clear;  ListBox2.Color:=clAqua;   ListBox2.Visible:=false;
  FileChanged:=false;  Caption:=ListBox1.Hint;
  s:='';  c:=0; k:=0; a:=0; lh:=0;  j:=0;  Current:=-1; n:=0;  Anal64:=0;
  Le1:=LatEqu1; for i:=1 to Length(Le1) do if Le1[i]=',' then Le1[i]:='''';
  Spec:=''; MaxLenS:=0; for i:=0 to 255 do stat[i]:=0;
  Numbered:=mnuNumerate.Checked;
  Repeat Inc(j);                                           // bytes read
    if c=0 then b:=GetByte else begin b:=c; c:=0; end;     // Read current byte
    if mnuMIMEQP.Checked and (b=Ord('='))
       then b:=(GetByteQP shl 4) or GetByteQP;             // MIMEQP-unpacking
    stat[b]:=stat[b]+1;                                    // increase counters
    if (a mod WHex)=0 then
    begin if a>0 then begin ListBox2.Items.Add(h1+'  '+h2); if lh=0 then lh:=Length(h1); end;
      h1:=Hex(a div 16384)+Hex((a div 256) mod 256)+Hex(a mod 256)+' :  '; h2:='';
    end;
    Inc(a); h2:=h2+Chr(b);  h1:=h1+Hex(b)+' '; if (a mod 4)=0 then h1:=h1+' ';
    if b=CR then Continue;             // end of Line
    if b=LF then begin Inc(k); PutStr; Gauge1.Progress:=j; Continue; end;
    if mnuRD.Checked then Dos2Win(b)   // Dos-
    else if mnuRK.Checked then         // Koi-
      begin
        i:=b-$C0 +1;
        if (i>0) and (Koi2Win[i]<>' ') then b:=Ord(Koi2Win[i]);
      end
    else if mnuRL.Checked then         // 
      begin
        cb:=Chr(b); if Last<=0 then c:=0 else c:=GetByte;   // next char
        if (Pos(Chr(c),'eua')>0) and ((cb='I') or (cb='i')) then cb:=Chr(b+1);  // ia -> ja
        for i:=1 to 64 do if cb=Le1[i] then
        begin
          if (Chr(c)=LatEqu2[i]) and (Chr(c)<>' ') then begin c:=0; b:=Ord(RusLet[i]); Break; end;
          if LatEqu2[i]=' ' then b:=Ord(RusLet[i]);
        end;
      end
    else if mnuRISO.Checked then         // ISO -6
      if (b and $80)=0 then
      begin                              // normal chars
        i:=b-$60 +1;
        if (i>0) and (Koi2Win[i+32]<>' ') then b:=Ord(Koi2Win[i+32]);
      end  else
      begin b:=b and $7F;               // packed blanks
        for i:=1 to b do s:=s+' ';
        b:=Ord(' ');
      end;
    h2[Length(h2)]:=Chr(b);             // to show in target code !
    s:=s+Chr(b);  if Length(s)>WrapL then PutStr;  // too long string;
    if (j>1000) and (k/j < 0.005) then
    begin Anons(' - ,    -  !',mtConfirmation);
      s:=''; ListBox1.Clear; ListBox2.Clear; Break;
    end;
  Until Last<=0;
  if s<>'' then PutStr;
  While Length(h1)<lh do h1:=h1+' ';  if h2<>'' then ListBox2.Items.Add(h1+'  '+h2);
  ListBox1.Visible:=true;  ListBox2.Visible:=true; Gauge1.Visible:=false;
  if mnuAsText.Checked then Front(1) else Front(2);
  for i:=0 to Memo1.Lines.Count-1 do if Copy(Memo1.Lines[i],1,3)='###' then
  begin for j:=Memo1.Lines.Count-1 downto i+1 do Memo1.Lines.Delete(j);
    Memo1.Lines.Add('   '+SourceFile);
    Memo1.Lines.Add(' : '+IntToStr(FileSize(f))+' ');
    Memo1.Lines.Add(' : '+IntToStr(k));
    Memo1.Lines.Add('.  : '+IntToStr(MaxLenS));
    Memo1.Lines.Add('    : ');  s:='';
    for j:=0 to 255 do
    begin a:=stat[j]; if a>9999 then a:=9999; if j<32 then cb:=' ' else cb:=Chr(j);
      s:=s+cb+' '+Hex(j)+' : '+Copy(IntToStr(a+10000),2,4)+'   ';
      if (j mod 4)=3 then begin Memo1.Lines.Add(s); s:=''; end;
    end;
    Top_Stat:=i; Break;
  end;
  CloseFile(f);
  mnuOptions.Enabled:=true; OptionsEnabled:=true;
  mnuWrite.Enabled:=true;
  mnuBackToLatin.Enabled:=mnuRL.Checked;
  Screen.Cursor:=crDefault;
  if NewSource and (Spec<>'') and mnuNoUnpack.Checked
    then Anons(Spec,mtInformation);
  NewSource:=false;
end;

procedure TfmRecode.mnuWriteClick(Sender: TObject);
var i,j,k:integer; s,s1:string; b,c:byte; cb:char;
begin  WCodeItem:=(Sender as TMenuItem);  WCodeItem.Checked:=true;
  s1:=SourceFile;
  for i:=Length(s1) downto 1 do if s1[i]='.' then
  begin s:=Copy(s1,i+1,255);
    if (s='dos') or (s='win') or (s='koi') or (s='lat') then Delete(s1,i,255);
    Break;
  end;
  Destination:=s1+'.'+WcodeItem.Hint;   // spec suffix
  s:=WCodeItem.Caption; i:=Pos('&',s); if i>0 then Delete(s,i,1);
  if ListBox1.Items.Count=0 then begin Anons(' !!!',mtConfirmation); Exit; end;
  Destination:=ChooseFileW('   ',Destination,'');
  if Destination='' then Exit;
  {$I-} AssignFile(f,Destination); Rewrite(f,1); {$I+}  Current:=1; Last:=MaxBuf;
  if IoResult<>0 then
    begin Anons(',     '+Destination,mtError); Exit; end;
  Gauge1.MaxValue:=ListBox1.Items.Count; Gauge1.Progress:=0; Gauge1.Visible:=true; Front(-1);
  Screen.Cursor:=crHourGlass;
  for i:=0 to ListBox1.Items.Count-1 do
  begin s1:=ListBox1.Items[i];  Gauge1.Progress:=Gauge1.Progress+1;
    if Numbered then System.Delete(s1,1,9);
    for j:=1 to Length(s1) do
    begin b:=Ord(s1[j]); c:=0;
      if b=$A8 then b:=Ord(''); if b=$B8 then b:=Ord('');  //   E - moe !!!
      if mnuWD.Checked then            // Dos-
      begin
        if b>=$F0 then Dec(b,16) else if b>=$C0 then Dec(b,64);
      end  else
      if mnuWK.Checked then            // Koi-
      begin
        if b>=$C0 then for k:=1 to 64 do if Ord(Koi2Win[k])=b then
          begin b:=$C0+k-1; Break; end;
      end  else
      if mnuWL.Checked then            // 
      begin
        for k:=1 to 64 do if b=Ord(RusLet[k]) then
        begin cb:=LatEqu1[k]; if cb=',' then cb:='''';
          b:=Ord(cb); cb:=LatEqu2[k]; if cb<>' ' then c:=Ord(cb);
        end;
      end;
      PutByte(b); if c<>0 then PutByte(c);
    end;
    if mnuDosLines.Checked then PutByte(CR);  PutByte(LF);
  end;
  Last:=Current-1; if Last>0 then PutByte(0);   // 
  Caption:=' '+Destination+'  '+s+'   (: '+IntToStr(FileSize(f))+' )';
  CloseFile(f); FileChanged:=false;
  Screen.Cursor:=crDefault;  Gauge1.Visible:=false;  Front(1);
end;

procedure TfmRecode.mnuBackToLatinClick(Sender: TObject);
var i,j,k:integer; s,s1:string; e:boolean;
begin e:=true;
  Screen.Cursor:=crHourGlass;  Front(0);
  for i:=0 to ListBox1.Items.Count-1 do if ListBox1.Selected[i] then
  begin s1:=ListBox1.Items[i]; e:=false; s:='';
    for j:=1 to Length(s1) do if Ord(s1[j])<$C0 then s:=s+s1[j] else
    begin k:=Ord(s1[j])-$C0+1;
      if LatEqu1[k]=',' then s:=s+'''' else s:=s+LatEqu1[k];
      if LatEqu2[k]<>' ' then s:=s+LatEqu2[k];
    end;
    ListBox1.Items[i]:=s;
  end;
  Screen.Cursor:=crDefault; Front(1);
  if e then Anons('  !',mtConfirmation);
end;

procedure TfmRecode.mnuCutSelectedClick(Sender: TObject);
var i:integer; e:boolean;
begin e:=true;
  Screen.Cursor:=crHourGlass; Front(0);
  for i:=ListBox1.Items.Count-1 downto 0 do if ListBox1.Selected[i] then
  begin e:=false; ListBox1.Items.Delete(i); FileChanged:=true; end;
  Screen.Cursor:=crDefault; Front(1);
  if e then Anons('       !',mtConfirmation);
end;

procedure TfmRecode.mnuLinesStyleClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:=true;
end;

procedure TfmRecode.mnuFinishClick(Sender: TObject);
begin
  if not FileChanged then Close;
  Anons('      ?'#13+'(   !!!)',mtWarning);
  FileChanged:=false;
end;

procedure TfmRecode.mnuTabsClick(Sender: TObject);
var i,j:integer; s1,s2:string;
begin for i:=0 to ListBox1.Items.Count-1 do
  begin s2:=''; s1:=ListBox1.Items[i];
    for j:=1 to Length(s1) do if s1[j]<>Chr(HT) then s2:=s2+s1[j] else
      begin FileChanged:=true; s2:=s2+Copy('         ',1,8-(Length(s2) mod 8)); end;
    ListBox1.Items[i]:=s2;
  end;
end;

procedure TfmRecode.KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Const cc:array[0..8] of TColor = (clWhite,clAqua,clLime,clRed,clYellow,clBlue,clSilver,clFuchsia,clGray);
begin mnuOptions.Enabled:=OptionsEnabled;
  Case Key of
  VK_Escape : if WhoIsOnFront=0 then Front(1) else mnuFinishClick(Sender);
  VK_F1     : begin mnuOptions.Enabled:=false;
                Memo1.Perform(WM_VSCROLL,sb_ThumbPosition,0);
                Front(0);
              end;
  VK_F4     : begin mnuAsText.Checked:=not mnuAsText.Checked;
                mnuAsHex.Checked:=not mnuAsText.Checked;
                if ListBox2.Items.Count=0 then Exit;
                if mnuAsText.Checked then Front(1) else Front(2);
              end;
  VK_F5     : begin if ColCount<8 then Inc(ColCount) else ColCount:=0;
                Case WhoIsOnFront of
                  0: Memo1.Color:=cc[ColCount];
                  1: ListBox1.Color:=cc[ColCount];
                  2: ListBox2.Color:=cc[ColCount];
                end;
              end;
  end;
end;

procedure TfmRecode.mnuAsHexClick(Sender: TObject);
begin
  mnuAsHex.Checked:=true;
  Front(2);
end;

procedure TfmRecode.mnuAsTextClick(Sender: TObject);
begin
  mnuAsText.Checked:=true;
  Front(1);
end;

procedure TfmRecode.mnuStatistClick(Sender: TObject);
begin
  Memo1.Perform(WM_VSCROLL,(Top_Stat shl 16)+sb_ThumbPosition,0);
  Front(0);
end;

procedure TfmRecode.mnuNumerateClick(Sender: TObject);
begin
  mnuNumerate.Checked:=not mnuNumerate.Checked;
  mnuReadClick(nil);
end;

procedure TfmRecode.mnuClearColClick(Sender: TObject);
begin
  mnuClearCol.Checked:=not mnuClearCol.Checked;
  mnuReadClick(nil);
end;

procedure TfmRecode.FormShow(Sender: TObject);
begin  Language:=Russian;
  if Param<>'?' then Exit;    // not 1-st call
  Memo1.Hint:=Caption;
  Param:=ParamStr(1);
  if Param='' then Exit;
  SourceFile:=Param;
  mnuReadClick(mnuRW);        // default=Windows code
end;

procedure TfmRecode.mnuPreambClick(Sender: TObject);
begin  (Sender as TMenuItem).Checked:=true; mnuReadClick(nil); end;

procedure TfmRecode.mnuNewFileClick(Sender: TObject);
var s:string;
begin s:=SourceFile; if s='' then s:=GetCurrentDir;
  s:=ChooseFileR('   ',s,'');
  if (s='') or (s=SourceFile) then Exit;
  NewSource:=true; SourceFile:=s;
  Caption:='    '+SourceFile;
  ListBox1.Clear;  ListBox1.Hint:=Caption;
  ListBox2.Clear;  ListBox2.Hint:=Caption;
  if Sender=mnuNewFile then mnuReadClick(nil);
end;

end.
